[//]: # ( Why hello there! Welcome to the ShareSuite readme. Feel free to use this as a basis for your readme :) )

# ShareSuite
#### By FunkFrog and Sipondo

This mod has been developed out of frustration of the item distribution in Risk of Rain 2.

Multiplayer RoR2 games should be quick wacky fun, but are often plagued by loot and chest sniping. This mod aims to fix that!

---

## Features

- Any item pickups (*non-gland and non-lunar by default*) are given to all living members of your party.

- Compatible with 3D Printers and Cauldrons - each player may consume their own items to earn an item from the cauldron. These items are given directly to the purchaser so that it does not affect other players' items.

- Toggleable scaling of boss loot and interactables spawning for balance.

- Configuration options for enabling/disabling sharing specific item types (*white, green, red, lunar, boss*).

- Config file (*RiskOfRain2/BepInEx/config/com.funkfrog_sipondo.sharesuite.cfg*) allows you to personalise the mod.

---

### TO-DO

Money Sharing 

- Sync host and client balance on game/map start to ensure no desyncs/incompatibilities with other mods. Set all money to host when shared money is enabled
- Split money properly before turning it into xp when the tp is hit.
- Check crowdfunder and brittle crown properly.

Extra Features 

- Custom Chat Messages
- Shared Equipment

---

### Installation Guide

- Copy the `SharedSuite.dll` file to your BepInEx plugins folder.
- Enjoy your items / money

---

### Configuration
1. **Make sure you run the game with the mod installed to generate the config file**
2. Navigate to `\Risk of Rain 2\BepInEx\config\`
3. Open `com.funkfrog_sipondo.sharesuite.cfg` in any text editor
4. Edit the values for settings as you see fit!

You can also set settings in-game with the commands listed below.

### Settings
| Setting                    | Default Value |                    Command |
| :------------------------- | :-----------: | -------------------------: |
| Mod Enabled                |          True |                 ss_Enabled |
| Money is Shared            |         False |           ss_MoneyIsShared |
| Money Scalar               |             1 |             ss_MoneyScalar |
| White Items are Shared     |          True |        ss_WhiteItemsShared |
| Green Items are Shared     |          True |        ss_GreenItemsShared |
| Red Items are Shared       |          True |          ss_RedItemsShared |
| Lunar Items are Shared     |         False |        ss_LunarItemsShared |
| Boss Items are Shared      |          True |         ss_BossItemsShared |
| Queens Glands are Shared   |         False |      ss_QueensGlandsShared |
| Dupe Fix                   |          True |      ss_PrinterCauldronFix |
| Override Player Scaling    |          True |   ss_OverridePlayerScaling |
| Interactables Credit       |             1 |     ss_InteractablesCredit |
| Override Boss Loot Scaling |          True | ss_OverrideBossLootScaling |
| Boss Loot Credit           |             1 |          ss_BossLootCredit |
| Dead Players Get Items     |         False |     ss_DeadPlayersGetItems |
| Blacklist                  |         Empty |                        N/A |

---

### FAQ
---

`How do 3d printers and cauldrons work?`

*3d printers and cauldrons directly add the item to your item pool. You will get the item directly instead of via an orb.*

---

`Does this make the game easier?`

*Technically, the game should be ever so slightly harder than vanilla this way. Either way it should be extremely close to the original game's balance.*

*For example, the amount of interactables (*chests, shrines, etc.*) is similar to that in a single player game.*

---

`How do I use Multitudes with this mod?`

*Please change the Disable Player Scaling setting and Disable Boss Loot Scaling to false in the config file. Multitudes will then take priority in modifying the scaling settings.*

---

`Why do I only get 1 item (plus shrine of the mountain drops) from the boss?`

*These items are shared as well, so you'll all get a copy. This can be configured with the Boss Loot Credit config setting.*

---

`How do blood shrines work when share money is on?`

*The user who uses the shrine loses health, but the calculations for how much gold they receive is done based on the highest max health player on your team.*

---

`I want to play this with my friends. Do they also need to install this mod?`

*This is always a good idea for stability, but is not required. This mod should still be fully functional if your friends only have BepInEx installed without the mod.*

---

`I want to play this mod with more than 4 players!`

*Please combine with [TooManyFriends](https://thunderstore.io/package/wildbook/TooManyFriends/). If you'd like to change the amount of boss drops or amount of chests, you can configure that in the config file.*

---

`How do I configure the mod while the game is running?`

*Open up the console window (``ctrl + alt + ` ``). All commands starts with `ss_` and will autocomplete.*

---

`Can I use this mod in quick play?`

*We DO NOT condone use of this mod in any quick play or prismatic trial games. Please respect our wishes and only use this mod in private lobbies.*

---

### Bug Reports, Suggestions & Feedback

Please feel free to contact us for suggestions/feedback/questions on discord (*`FunkFrog#0864` or `Sipondo#5150`*).

---

### Tested Compatibility

- [RolltheRain](https://thunderstore.io/package/Sipondo/RolltheRain/)
- [Multitudes](https://thunderstore.io/package/wildbook/Multitudes/)
	- Please see the *How do I use Multitudes with this mod?* FAQ.
- [TooManyFriends](https://thunderstore.io/package/wildbook/TooManyFriends/)
- [DropInMultiplayer](https://thunderstore.io/package/Morris1927/DropinMultiplayer/)

#### Incompatible Mods

Mod Developers of these mods: If you are open to collaborate with us, we'd love to work with you to resolve the conflict!

- [KookehsDropItem](https://thunderstore.io/package/tristanmcpherson/KookehsDropItem_BepInEx/) 
- [Command Artifact](https://thunderstore.io/package/felixire/Command_Artifact/) - Gives items directly to inventory, which breaks sharing. Can be fixed by dropping a new ItemDroplet instead of giving directly.

---

### Changelog

`1.5.2` - Fixed a conditional that kept boss loot scaling from ever activating. Removed a hard coded testing number that was unintentionally left in the code. (Thanks to jkbbwr for finding these two bugs)!
New & Improved README! Now with a fancy table (that doesn't really work on the site yet but that's okay.)

`1.5.1` - Boss Loot Drop scalar now features live update support!

`1.5.0` - Definitive fix of all known bugs. Capsules now scale their money properly.

`1.4.2` - Fixed reflection.

`1.4.1` - README.md fix.

`1.4.0` - Introduced item blacklisting, made item sharing behave like Loot4All again.

`1.3.0` - Introduced ingame config commands

`1.2.0` - Shared money alpha.

`1.1.1` - Fix of logic concerning 3D printers and Cauldrons.

`1.1.0` - Addition of config option for sharing/not sharing Queen's Glands.

`1.0.1` - Update of the README.md with a new to-do entry and a new FAQ, as well as a slight modification of the manifest.

`1.0.0` - Initial release, merged Loot4All and FunkFrog Shared Items.
